#--
#
#################################################################################
# Copyright 2011 CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# Controlador encargado de la gestión de socio. Este controlador es utilizado desde las secciones:
# * Sección socio: se utiliza para visualizar los pagos de los socios y crear pago de un socio


class PagoSocioController < ApplicationController


  # por defecto redirecionamos hacia ordenado pago
  def index
    session[:socio_seleccionado] = nil
    redirect_to :action => 'ordenado_pago'
  end

	# en pago_socio: lista los pagos de los socios
  def listado_pago
    if session[:socio_seleccionado]
      @pagos =  PagoSocio.paginate(:all, :conditions => { :socio_id => session[:socio_seleccionado].id }, :order => ( ( session[:pago_orden] || "concepto" ) + " " + ( session[:pago_asc_desc] || "ASC" ) ), :page => params[:page], :per_page => (session[:por_pagina] or 20) ) 
    else
      @pagos =  PagoSocio.paginate(:all, :order => ( ( session[:pago_orden] || "concepto" ) + " " + ( session[:pago_asc_desc] || "ASC" ) ), :page => params[:page], :per_page => (session[:por_pagina] or 20) )
    end
  end

  # en pago_socio: establece los parametros de ordenación de los pagos
  def ordenado_pago
    session[:pago_asc_desc] = params[:asc_desc] ? params[:asc_desc] : "ASC"   
    session[:pago_orden] = params[:orden] ? params[:orden] : "concepto" 
    redirect_to :action => "listado_pago"
  end
  
  # en pago_socio: prepara el formulario de edición o creación de pago
  def editar_nuevo_pago
    @pago = params[:id] ?  PagoSocio.find(params[:id]) : nil
    @socios = session[:socio_seleccionado] ? [session[:socio_seleccionado]].collect {|p| [p.nombre, p.id]} : Socio.find(:all).collect {|p| [p.nombre + " " + p.apellido1 + " " + p.apellido2, p.id]}
    render :partial => "formulario_pago"
  end

	# en pago_socio: modifica o crea un pago
  def modificar_crear_pago
    @pago = params[:id] ?  PagoSocio.find(params[:id]) : PagoSocio.new 
    @pago.update_attributes params[:pago]
    flash[:error] = @pago
    redirect_to :action => "listado_pago"
  end

	# en pago_socio: elimina un pago
  def eliminar_pago
    @pago = PagoSocio.find(params[:id])
    @pago.destroy
    flash[:error_eliminar] = @pago
    redirect_to :action => 'listado_pago'
  end

end
