#--
#
#################################################################################
# Copyright 2011 CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# metodos utilizados en todas las "views"

#--
# ABORRAR: 27 de abril de 2010
#++
module ApplicationHelper

  #--
  # METODOS PARA SALIDAS XLS
  #--

  def formato_xls_negrita
    return Spreadsheet::Format.new :weight => :bold, :align => :top, :text_wrap => true, :number_format => '#,##0.00'
  end
  def formato_xls_negrita_centrado
    return Spreadsheet::Format.new :weight => :bold, :align => :top, :text_wrap => true, :number_format => '#,##0.00', :horizontal_align=>:center
  end
  def formato_xls_normal
    return Spreadsheet::Format.new :text_wrap => true, :align => :top, :number_format => '#,##0.00'
  end
  def formato_xls_cabecera
    return Spreadsheet::Format.new :weight => :bold, :align => :middle, :pattern => 1, :pattern_fg_color => :aqua
  end
  def formato_xls_centrado_resaltado
    return Spreadsheet::Format.new :text_wrap => true, :align => :middle, :number_format => '#,##0.00', :horizontal_align=>:center, :pattern => 1, :pattern_fg_color => :silver
  end

  #--
  # METODOS GENERALES
  #++

  # helper de generacion de iconos con image_tag
  def icono tipo, *rotulo
    image_tag("/images/iconos_bn/" + tipo + ".png", :border => 0, :class => "icono", :title => rotulo[0] || "", :onmouseover => "this.src='/images/iconos_bn/" + tipo + "_s.png';", :onmouseout => "this.src='/images/iconos_bn/" + tipo + ".png';" )
  end


  #--
  # METODOS DE  FORMULARIO
  #++

  # ajax true o false para form_remote_tag o form_tag
  def comienzo_formulario url, ajax, otros={}
    if ajax
      cadena = form_remote_tag( :url => url, :html => {:id => "formulario", :class => "formulario"}, :multipart => true, :before => "tinyMCE.triggerSave(true, true);", :loading => "Element.show('spinner'); Element.hide('botonguardar');", :complete => "Element.hide('spinner')")
    else
      cadena = form_tag( url, :multipart => true, :class => "formulario" )
    end
    cadena << "<div class='fila' id='spinner' style='display:none'></div>"
    cadena << "<div class='fila'></div>\n"

    return cadena
  end

  # submit_tag con botón guardar
  def final_formulario boton={}
    cadena = '<div class="fila" id="botonguardar" > <div class="elementoderecha">'
    cadena << submit_tag((boton[:texto_alternatif] || "Guardar"), :class => "boton", :onclick => "this.disabled=true")
    cadena << "</div></div>"
    cadena << "</FORM>"
  end

  # A FUSIONAR CON "TEXTO" text_field para colocarle un rotulo e incluirlo en un div con la clase, y le pone como clase al campo texto "textonumero".
  def texto_numero rotulo , objeto, atributo, clase, otros={}
    "<div class=\"elemento"+ clase +"\">" + rotulo +"<br/>" + text_field( objeto, atributo , {:class => "textonumero"+clase, :type => "d", :name => otros[:name], :value => otros[:value], :onchange => otros[:onchange]}) + "</div>"
  end

  # text_field con un rotulo e incluirlo en un div con la clase.
  def texto rotulo , objeto, atributo, clase, otros={}
    cadena = "<div class=\"elemento"+ clase +"\">" + rotulo +"<br/>"
    if otros[:autocomplete]
      cadena << text_field_with_auto_complete( objeto, atributo, {:class => "texto" + clase}, {:method => :get, :with => "'search=' + element.value", :onchange => otros[:onchange]} )  
    else
      cadena << text_field( objeto, atributo , {:class => "texto"+clase, :type => "d", :name => otros[:name], :onchange => otros[:onchange]})
    end
    return cadena << "</div>"  
  end

  # text_area con un rotulo e incluirlo en un div con la clase.
  # si la clase que se pasa es "editor_rico" incluye un Wysiwyg javascript (tyny_mce)
  def texto_area rotulo , objeto, atributo, clase, *otros
    if clase == "editor_rico"
      include_tiny_mce_if_needed
      "<div class=\"elemento\">" + rotulo +"<br/>" + text_area( objeto, atributo , {:class => "mceEditor", :type => "d", :name => otros[0]}) + "</div>"
    else
    "<div class=\"elemento"+ clase +"\">" + rotulo +"<br/>" + text_area( objeto, atributo , {:class => "textoarea"+clase, :type => "d", :name => otros[0]}) + "</div>"
    end
  end

  # password_field con un rotulo e incluido en un div con la clase (se utiliza solamente en app/views/usuario/entrada.rhtml y en app/views/usuario/_formulario.rhtml
  def contrasena rotulo , objeto, atributo, clase
    "<div class=\"elemento"+ clase +"\">" + rotulo +"<br/>" + password_field( objeto, atributo , {:class => "texto"+clase }) + "</div>"
  end

  # select con un rotulo e incluido en un div con la clase.
  def selector rotulo , objeto, atributo, valores, vacio, clase, otros={}
    options = {:include_blank => vacio}
    options[:selected] = otros[:selected] if otros[:selected]
    "<div class=\"elemento"+ clase +"\" id=\"selector_" + objeto + "_" + atributo + "\">" + rotulo +"<br/>" + select( objeto, atributo , valores, options , {:class => "selector"+clase, :name => otros[:name], :size => otros[:size] ? otros[:size] : 1 }  ) + "</div>"
  end

  # check_box 
  def checkbox rotulo, objeto, atributo, clase, otros={}
    otros[:disabled]
    if otros[:izquierda]
      "<div class=\"elemento"+ clase +"\">" + ( ("<br>" if otros[:abajo]) || "") +  check_box( objeto, atributo, {:checked => otros[:checked]} ) + rotulo + "</div>"
    else
      "<div class=\"elemento"+ clase +"\">" + rotulo + check_box( objeto, atributo, {:checked => otros[:checked]} ) + "</div>"
    end
  end

  # seleccionar día, mes y año (si hay en la misma pagina feche_inicio y fecha_fin, a cerrar el calendario para fecha_fin se alerta si fecha_inicio > fecha_fin)
  def calendario_fecha rotulo, objeto, atributo, otros={}
    if atributo == "fecha_fin"
      otros[:after_close] = 'fecha = document.getElementById("fecha_fecha_inicio").value.match(/\d+/g); fecha_inicio = new Date( ); fecha_inicio.setFullYear(fecha[2]); fecha_inicio.setMonth(fecha[1] - 1); fecha_inicio.setDate(fecha[0]); fecha = this.value.match(/\d+/g); fecha_fin = new Date( ); fecha_fin.setFullYear(fecha[2]); fecha_fin.setMonth(fecha[1] - 1); fecha_fin.setDate(fecha[0]); if (fecha_fin < fecha_inicio) alert("Cuidado! la fecha de fin es major que la fecha de inicio")'
  end
    otros[:year_range] =  [1930, Time.now.year + 5] if  otros[:year_range].nil?
    otros[:size] = "10"
    otros[:onchange] = 'fecha = this.value.replace(/(\d+)\/(\d+)\/(\d+)/, "$3-$2-$1");  document.getElementById("' + objeto + "_" + atributo + '").value = fecha'
    javascript_tag( 'fecha = document.getElementById("' + objeto + '_' + atributo + '").value; if ( fecha ) {fecha_en_array = fecha.match(/\d+/g); ano = fecha_en_array[0]; mes = fecha_en_array[1]; dia = fecha_en_array[2]; fecha = dia + "/" + mes + "/" + ano; document.getElementById("fecha_' + objeto + "_" + atributo + '").value = fecha } ' ) +
    "<div class=\"elemento3_4\">" + rotulo +"<br/>" + calendar_date_select( "fecha_" + objeto, atributo, otros ) + "</div>" + hidden_field(objeto, atributo)
  end

  # solamente para seleccionar mes y años
  def mes_fecha rotulo , objeto, atributo, otros={}
    otros[:start_year] = 1930 if not otros[:start_year]
    otros[:end_year] = Time.now.year + 10 if not otros[:end_year]
    otros[:use_month_numbers] = false if not otros[:use_month_numbers]
    otros[:order] = [:day,:month,:year] if not otros[:order]
    otros[:include_blank] = false if not otros[:include_blank]
    otros[:discard_day] = true if not otros[:discard_day]
    '<div class="elemento1">' + rotulo +'<br/>' + date_select(objeto, atributo, otros, {:class => 'fecha'}) + '</div>' 
  end

  # solamente por seleccionar el año.
  def ejercio_fecha rotulo, id, ano_selectada, visible, otros={}
    ano = ano_selectada ? ano : Date.today
    display = visible ? "\"\"" : "none"
    "<div id=\"" + id + "\" class=\"elemento1\" style=\"display: " + display  + "\" >" + rotulo +"<br/>" + select_year(ano, otros, {:class => "fecha"}) + "</div>"
  end

  #-- METODOS DE  LISTADO
  #++
  # el array que devuelve el helper reponde al modelo : rotulo, ancho de columna (hasta 9_2, 4,5), atributo y si true entonces con posibilidad de ordenado si se pasa a cabecera_listado
  def campos_listado modelo
    case modelo
      when "proyecto" then [[_("Nombre"),"1", "nombre", true ], [_("Título"),"5_2", "titulo", false ], [_("Estado"),"1_2","estado_actual.definicion_estado.nombre"] , [_("Agente"),"1_2", "agente.nombre", true]]
      when "usuario" then [["Usuario","1", "nombre" ],  ["Nombre Completo","2", "nombre_completo"], ["Correo","1","correoe"] ,["Administrador","1_2", "administracion"]]
      when "usuario_x" then [ [ "Usuario", "1", "usuario.nombre" ],[ "Rol", "3_4", "rol"] ]
      when "pais" then
        if params[:seccion] == "administracion"
          [["Pais","2", "nombre", true], ["Area Geográfica", "2", "area_geografica.nombre", true]]
        else
          [["Pais","1", "nombre"], ["Area Geográfica", "1_2", "area_geografica.nombre"]]
        end
      when "moneda" then [["Moneda","1", "nombre",true], ["Abreviatura","1_2", "abreviatura",true]]
      when "partida" then [ [_("Código"),"1_2", "codigo", true ],[_("Nombre"),"1", "nombre", true], [_("Tipo"),"1_2", "tipo_mayusculas"],[_("Ocultar en agente"),"1", "ocultar_agente", true],[_("Descripción"),"1", "descripcion"]]
      when "area_geografica" then [["Nombre", "3_2", "nombre",true], [_("Descripción"),"3_2", "descripcion"]]
      when "sector_poblacion" then [["Nombre", "3_2", "nombre",true ], [_("Descripción"),"3_2", "descripcion"]]
      when "sector_intervencion" then [["Nombre", "3_2", "nombre",true], [_("Descripción"),"3_2", "descripcion"]]
      when "area_actuacion" then [["Nombre", "3_2", "nombre", true], [_("Descripción"),"3_2", "descripcion"]]
      when "agente" then [["Nombre", "1", "nombre", true], ["Nombre completo", "2", "nombre_completo"], ["Financiador", "1_2", "financiador", true], ["Implementador", "1_2", "implementador", true]]
      when "financiacion" then [["Nombre","1", "nombre", true ],  ["Título","2", "titulo"], ["Financiador","1","financiador.nombre", true]]
      when "libro" then [[_("Nombre"),"1", "nombre", true ],[_("Agente"),"3_4", "agente.nombre", true], ["Moneda","1_3", "moneda.abreviatura"], [_("Pais"),"1_2", "pais.nombre", true], [_("Cuenta"),"3_4", "cuenta"], [_("Tipo"),"1_2", "tipo.capitalize", true]]
      when "proyecto_cofinanciado" then [["Nombre", "1", "nombre", true], [_("Título"),"5_2", "titulo", false ] ]
      when "proyecto_cofinanciador" then [["Nombre", "1", "nombre", true], [_("Título"),"5_2", "titulo", false ] ]
      when "documento" then [["Nombre", "1", "adjunto_file_name", true], ["Estado", "1_3", "estado", true], ["Descripción", "3", "descripcion"]]
      when "objetivo_especifico" then [[_("Codigo"),"1_2","codigo"],[_("Descripción"),"2","descripcion"]]
      when "resultado" then [[_("Codigo"),"1_2","codigo"],[_("Descripción"),"2","descripcion"]]
      when "etapa" then [ [_("Nombre"),"1", "nombre"], [_("Fecha inicio"),"1_2", "fecha_inicio" ],[_("Fecha fin"),"1_2", "fecha_fin"], [_("Meses"),"1_4", "meses" ], [_("Descripción"),"3_2", "descripcion"]]
      when "financiador" then [["Nombre", "1", "nombre"]]
      when "implementador" then [["Nombre", "1", "nombre"]]
      when "actividad" then [["Código y descripción", "3", "codigo_descripcion"]]
      when "gasto" then [ [_("Fecha"),"1_3", "fecha", true], [_("Importe"),"1_2_td", "gasto_x_proyecto.first.importe", true],["&nbsp;","1_4", "moneda.abreviatura", true], [_("Partida"),"3_4","partida.codigo_nombre " + (@proyecto ? @proyecto.id.to_s : "nil"), true], [_("Concepto"),"1", "concepto", true], [_("Implementador"), "1", "agente.nombre", true] ]
      when "gasto_cofinanciable" then [ [_("Fecha"),"1_3", "fecha", true], [_("Importe"),"1_2_td", "importe", true],["&nbsp;","1_4", "moneda.abreviatura", true], [_("Partida"),"3_4","partida.codigo_nombre " + (@proyecto ? @proyecto.id.to_s : "nil"), true], [_("Concepto"),"1", "concepto", true], [_("Implementador"), "3_4", "agente.nombre", true], [_("Proyecto Origen"),"1", "proyecto_origen", true] ]
      when "gasto_agentes" then [ [_("Fecha"),"1_3", "fecha", true], [_("Importe"),"1_2_td", "importe", true],["&nbsp;","1_4", "moneda.abreviatura", true], [_("Partida"),"3_4","partida.codigo_nombre", true], [_("Concepto"),"3_2", "concepto", true], [_("Nº Factura"), "1_2", "numero_factura"] ]
      when "presupuesto" then [[_("Partida"),"3_4", "partida.codigo_nombre " + @proyecto.id.to_s, true], [_("Importe"),"1_2_td", "importe" ],["&nbsp;","1_4", "moneda.abreviatura"], [_("Subpartida"),"1", "subpartida.nombre", true], [_("Concepto"),"1", "concepto", true], [_("Agente"), "1_2", "agente.nombre"]]
      when "presupuesto_agentes" then [[_("Partida"),"3_4", "partida.codigo_nombre", true], [_("Importe"),"1_2_td", "importe" ],["&nbsp;","1_4", "moneda.abreviatura"], [_("Subpartida"),"1", "subpartida.nombre", true], [_("Concepto"),"1", "concepto", true], [_("Agente"), "1_2", "agente.nombre"]]
      when "definicion_estado" then [[_("Nombre"),'1','nombre',true], [_("Descripción"), '2', 'descripcion'], [_("Estado anterior"), '1', 'estado_padre.nombre'], [_("Primer estado"), '1_2', 'primer_estado'] ]
      when "definicion_dato" then [[_("Nombre"),'1','nombre',true], [_("Rotulo"), '3_2', 'rotulo'], [_("Tipo"), '1_2', 'tipo'], [_("Pestaña"), '1', 'pestana',true], [_("Rango"),'1_2','rango' ] ]
      when "estado" then[[_("Nombre"), '1', 'definicion_estado.nombre'], [_("Fecha inicio"), '3_4', 'fecha_inicio'], [_("Fecha cambio"), '3_4', 'fecha_fin'], [_("Cambiado por"), '1', 'usuario.nombre'] ]
      when "tarea" then[[_("Tipo tarea"), '1_2', 'tipo_tarea.nombre', true], [_("Título"), '3_2', 'titulo', true], [_("Fecha inicio"), '1_2', 'fecha_inicio', true], [_("Fecha fin"), '1_2', 'fecha_fin', true], [_("Asignado a"), '1_2', 'usuario_asignado.nombre'], [_("Asignado por"), '1_2', 'usuario.nombre'], [_("Estado"), '1_2', 'estado_tarea.nombre', true] ]
      when "tipo_tarea" then[[_("Nombre"), '1', 'nombre',true], [_("Descripción"), '2', 'descripcion'], [_("De proyecto"), '3_4', 'tipo_proyecto']]
      when "estado_tarea" then[[_("Nombre"), '1', 'nombre',true], [_("Descripción"), '1', 'descripcion'], [_("Activo"), '1_2', 'activo']]
      when "comentario" then[[_("Comentario"), '5_2', 'cuerpo'], [_("Fecha"), '1_2', 'fecha'], [_("Usuario"), '1_2', 'usuario']]
      when "transferencia" then [ [_("Fecha"),"1_3", "fecha", true], [_("Importe"),"1_2_td", "importe" ],["&nbsp;","1_4", "moneda.abreviatura"], [_("Cuenta"),"1", "libro.nombre", true], [_("Tipo"), "3_4", "tipo_completo", false], [_("Descripción/Observaciones"), "1", "observaciones"], [_("T.Cambio"), "1_3_td", "tasa_cambio"]]
      when "partida_financiacion" then [[_("Código"),"1_2", 'codigo'],[_("Nombre"),"1", 'nombre'], [_("Descripción"),"1", 'descripcion'], [_("Tipo"),"1_4", 'tipo_mayusculas']]
      when "proyecto_x_financiacion" then [[_("nombre del proyecto"), "1", 'proyecto.nombre'], [_("Nombre en financiacion"),"1",'nombre_en_financiacion'], [_("Título en financiacion"), "2", 'titulo_en_financiacion']]
      when "indicador" then [[_("Código"), "1", 'codigo'], [_("Descripción"), "2", 'descripcion'], [_("Porcentaje"), "1_4", 'porcentaje']]
      when "fuente_verificacion" then [ [_("Código"), "1", 'codigo'], [_("Descripción"), "2", 'descripcion'], [_("Indicador"), "1_2", "indicador.codigo"]]
      when "hipotesis" then [ [_("Descripción"), "3", 'descripcion'] ]
      when "cabezera_fuente" then [["Fuente de Verificación", "1", ""]]
      when "socio" then [ [_("Nombre"), "1_2", "nombre", true], [_("Apellido"), "1_2", "apellido1", true],  [_("Naturaleza"), "1_2", "naturaleza_socio.naturaleza", true], [_("Sexo"), "1_4", "sexo", true],  [_("Pais"), "1_2", "pais", true], [_("Provincia"), "1_2", "provincia", true] ]
      when "informacion_socio" then [ [_("Fecha Alta"), "1", "fecha_alta", true], [_("Importe Cuota,"), "1", "importe_cuota,", true], [_("Activo"), "1_4", "activo", true], [_("Naturaleza Socio"), "1", "naturaleza_socio", true] ]
      when  "pago_socio" then [[_("Socio"), "1", "socio.nombre_completo", true], [_("Importe"), "1_2", "importe", true],  [_("Concepto"), "3_2", "concepto", true], [_("Fecha pago"), "1_2", "fecha_pago", true], [_("Fecha Emisión"), "1_2", "fecha_emision", true]]
      when "etiqueta" then [[_("Etiqueta"), "1", "nombre", true], [_("Tipo"), "1_2", "tipo.capitalize", true], [_("Descripción"), "2", "descripcion"]]
      when "presupuesto_x_actividad" then [[_("Partida"),"3_4", "presupuesto.partida.codigo_nombre " + @proyecto.id.to_s, true], [_("Importe"),"1_2_td", "importe" ],["&nbsp;","1_4", "presupuesto.moneda.abreviatura"], [_("Subpartida"),"1", "presupuesto.subpartida.nombre", true], [_("Concepto"),"1", "presupuesto.concepto", true], [_("Agente"), "1_2", "presupuesto.agente.nombre"]]
      when "pago" then [ [_("Fecha"),"1_3", "fecha", true], [_("Cuenta"),"1", "libro.nombre", true], [_("Importe"), "1_2_td", "importe", true],["&nbsp;","1_4", "gasto.moneda.abreviatura", true], [_("Observaciones"),"3_2", "observaciones", true] ] 
      when "factura" then [ [ _("Código"), "3_2", "orden_factura"], [_("Fecha"),"1_3", "gasto.fecha"], [_("Importe"), "1_2_td", "gasto.importe"], ["&nbsp;","1_4", "gasto.moneda.abreviatura"], [_("Factura"), "3_4", "gasto.numero_factura"], [_("Agente Implementador"), "1", "gasto.agente.nombre"] ]
      when "variable_indicador" then [ [_("Indicador"), "1", "indicador.codigo_completo"], [ _("Variable"), "2", "nombre" ], [ _("Valor Base"), "1_2", "valor_base.valor"], [ _("Valor Objetivo"), "1_2", "valor_objetivo.valor"], [_("Última medida"), "1_2", "ultimo_valor.valor"] ]
      when "valor_medido" then [ [_("Fecha"), "1_3", "fecha", true], [_("Valor"), "1_2", "valor"], [_("Comentario"), "2", "comentario"] ]
      when "subactividad" then [ [_("Descripción"), "3", "descripcion"], [_("Estado"), "1_2", "estado"], [_("Fecha inicio"), "1_2", "fecha_inicio"], [_("Fecha fin"), "1_2", "fecha_fin"] ]
      when "marcado" then [ [_("Nombre"), "3_4", "nombre"],  [_("Descripción"), "3_2", "descripcion"], [_("Color"), "1_2", "color"], [_("Marcado anterior"), "1", "marcado_padre.nombre"], [_("Primer estado"), "1_2", "primer_estado"] ]
      when "definicion_estado_documento" then [["Nombre", "1", "nombre", true], ["Descripción", "2", "descripcion"]]
      when "definicion_estado_tarea" then [["Titulo", "1", "titulo", true], ["Descripción", "2", "descripcion"]]
    end
  end

  # el array que devuelve el helper reponde al modelo : rotulo, ancho de columna (hasta 9_2, 4,5), atributo.
  def campos_info modelo
    case modelo
      when "gasto" then [ ["Subpartida", "1", "subpartida_proyecto_nombre " + @proyecto.id.to_s ], [_("Nº Factura"), "1_2", "numero_factura"], [_("Emisor Factura"), "1", "emisor_factura"], [_("DNI Emisor"), "1_2", "dni_emisor"], [_("Tipo Partida"), "3_4", "partida.tipo"], [_("Observaciones"), "1", "observaciones"], [_("Impuestos"), "1_2", "impuestos"], [_("Actividades"), "1", "importes_por_actividades " + @proyecto.id.to_s], [_("Financiadores"), "1", "importes_por_financiadores " + @proyecto.id.to_s] ]
      when "gasto_cofinanciable" then [ [_("Nº Factura"), "1_2", "numero_factura"], [_("Emisor Factura"), "1", "emisor_factura"], [_("DNI Emisor"), "1_2", "dni_emisor"], [_("Tipo Partida"), "3_4", "partida.tipo"], [_("Observaciones"), "1", "observaciones"], [_("Impuestos"), "1_2", "impuestos"], [_("Proyectos"), "1", "importes_por_proyectos"] ]
      when "gasto_agentes" then [ [_("Subpartida"), "1", "subpartida_agente.nombre"], [_("Emisor Factura"), "1", "emisor_factura"], [_("DNI Emisor"), "1_2", "dni_emisor"], [_("Tipo Partida"), "3_4", "partida.tipo"], [_("Observaciones"), "1", "observaciones"], [_("Impuestos"), "1_2", "impuestos"], [_("Proyectos"), "2", "importes_por_proyectos"] ]
      when "presupuesto" then [[_("Observaciones"), "1", "observaciones"], [_("Nº Unidades"), "1_2", "numero_unidades"], [_("C.Unitario"), "1_2_td", "coste_unitario"], [_("Etapa"), "1", "etapa.nombre"], [_("Actividades"), "1", "importes_por_actividades"], [_("Financiadores"), "1", "importes_por_financiadores"]]
    end
  end

  # Pone la cabecera a listado siendo cabecera un array con las columnas de los elementos listados y otros los posibles campos para un icono
  # otros[0] => titulo del icono
  # otros[1] => acción del icono
  # otros[2] => id del icono
  # otros[3] => alternativa al icono anadir_relacion
  # cabecera es el array de arrray con rotulo, elemento, campo, ordenado resultado de campos_listado modelo
  def cabecera_listado cabecera, *otros
   cadena = comienzo_listado
   cadena << "<div class='filacabecera'>\n"
   cadena << cabecera.inject(""){|todos, e| todos + elemento_cabecera(e[0], e[1], e[2], e[3]) }
   cadena << "<div class='elementoderecha'>\n"
   cadena << link_to( icono( "descargar", _("Exportar a XLS" )), request.parameters.merge({:format => :xls, :format_xls_count => @formato_xls}) ) if @formato_xls
   cadena << modal( icono((otros[3] || 'anadir')), otros[1], otros[0], otros[2] || {:id => "anadir"}) if otros[0] && otros[1]

   return cadena << "</div><div class='linea'></div></div>\n"
  end


  # TODO: Rehacer el metodo para que utilice un hash y no un array en la variable otros. Implica cambiar todas las llamadas que lo utilizan
  # No es buena practica dejar codigo comentado pero antes de la versión 2.0.2 implementaremos este cambio.
  # < PROPUESTA DE NUEVO MODELO >

#  def cabecera_listado2 cabecera, icono, otros={}
#   cadena = comienzo_listado
#   cadena << "<div class='filacabecera'>\n"
#   cadena << cabecera.inject(""){|todos, e| todos + elemento_cabecera(e[0], e[1], e[2], e[3]) }
#   cadena << "<div class='elementoderecha'>\n"
#   cadena << modal( icono((otros[:icono_dos][:imagen] || 'anadir')), otros[:icono_dos][:url], otros[:icono_dos][:texto], {:id => (otros[:icono_dos][:id] || "anadir")}) if otros[:icono_dos]
#   cadena << "&nbsp;"
#   cadena << modal( icono((icono[:imagen] || 'anadir')), icono[:url], icono[:texto], {:id => (icono[:id] || "anadir")}) if icono
#   return cadena << "</div><div class='linea'></div></div>\n"
#  end

  # </ PROPUESTA DE NUEVO MODELO >



  # Dibuja cada uno de los elmentos de una cabecera.
  def elemento_cabecera rotulo, clase, atributo, ordenado
    asc_desc = session["#{params[:controller]}_asc_desc".to_sym] == "ASC" ? "DESC" : "ASC"
    if atributo == session["#{params[:controller]}_orden".to_sym]
      icono = (asc_desc == "ASC" ?  image_tag("orden_asc.gif") : image_tag("orden_desc.gif"))
    end

    rotulo = link_to( rotulo , {:action => :ordenado, :orden => atributo, :asc_desc => asc_desc, :listado => controller.action_name}) if ordenado
    '<div id="cabecera_' + atributo + '" class="elemento' + clase + '">' + rotulo + "  " + (icono || "") +"</div>"
  end

  # Diduja los elementos del comienzo del listado
  def comienzo_listado
    return '<div class="listado">'
  end

  # Dibuja los elementos del final de un listado.
  def final_listado *listado
    cadena = "</div>"
    cadena << paginacion( listado[0], session[:por_pagina] ) if listado[0]
    return cadena
  end


  # Metodo que dibuja el formulario de filtrado. Parametros:
  # * El nombre de la accion de filtrado.
  # * Los rotulos del estado del filtrado.
  # * Y las opciones de filtrado.
  # NOTA: La presentacion esta pensada para que se puedan poner varias opciones de filtro.
  def formulario_filtrado url_accion, estado_filtro, opciones_filtro
    cadena =  '<fieldset class="filtrado">'
    # En lugar usar :listado dentro de url_accion y obligar a las vistas a meter de donde vienen,
    # se podria usar controller.action_name para averiguarlo automaticamente
    cadena << comienzo_formulario( url_accion, nil, false )
    cadena << '<div class="elementofiltrado"> ' + _("Filtrado por") + ' &nbsp; </div> <div class="elementofiltrado">'
    for estado in estado_filtro
      cadena << ' >> <i>  '+ estado +'</i><br />'
    end
    cadena << '</div> <div class="elementoderecha"><div class="elemento4"><div class="elementoderecha">'
    for filtro in opciones_filtro
      session[(controller.controller_name+"_filtro_"+filtro[:nombre]).to_sym]
      cadena << selector( filtro[:rotulo], 'filtro', filtro[:nombre], filtro[:opciones], false, "3_4", {:selected => session[(controller.controller_name+"_filtro_"+filtro[:nombre]).to_sym].to_i} )
    end
    cadena << '<div class="elemento1_4"> '  + submit_tag(_("Filtrar"), :class => "boton1_2") + '</div>'
    cadena << '</div></div></div></form>'
    cadena << '</fieldset>'
    return cadena
  end



  def comienzo_sublistado rotulo, sub_id
      script = "document.getElementById('" +  sub_id + "').innerHTML=\"\";"
      cadena = '<fieldset class="sublistado"> <legend>'+ rotulo +'</legend>'
      cadena << '<div class="linea"><div class="elementoderecha" id="cerrarsublistado">'
      cadena << link_to_function( icono( "cerrar", "Ocultar sublistado"), script, {:id => sub_id + "_ocultar_sublistado"} )
      cadena << '</div>'
  end

  # Dibuja los elementos del final del sublistado.
  def final_sublistado
      return "</fieldset>"
  end

  # dibuja cada fila del listado
  def fila_listado objeto, campos, id
    return campos.inject(""){|todos, e| todos + elemento_listado(objeto, e[2], e[1], e[2], id)}
  end

  # Caracteres que pueden tener cada uno de los anchos de los elementos de los listados
  # La nomenclatura es como sigue:
  # La clave de la Hash 1, 2, 3,... hace referencia al elemento1, elemento2,... al que le corresponde un estilo determinado en el css.
  # Y el valor al que va asociado es el numero de caracteres para el ancho de ese tipo de elemento.
  # Ejemplo: el elemento1 (que son 250px) caben 32 caracteres.
 CARACTERES = { "4" => 128, "3" => 87, "5_2" => 74 ,  "2" => 64, "3_2" => 45, "1"  => 28, "3_4" => 21, "1_2" => 13, "1_3" => 11, "1_4"=> 10 , "1_8" => 5 }
  def caracteres tipo
    return CARACTERES[tipo.split("_td")[0]]||28
  end

  # dibuja cada elemento del listado
  def elemento_listado objeto, campo, clase, nombre, id
    begin
      #campo.split('.').each { |metodo| objeto = objeto.send(metodo)}
      campo.split('.').each { |metodo| objeto = (metodo =~ /(\S+)\s(\S+)/ ? objeto.send($1,$2) : objeto.send(metodo)) }
      case campo
        when  "financiador",  "implementador", "primer_estado", "tipo_proyecto", "tipo_financiacion", "activo", "administracion", "ocultar_agente"
          then "<div id=\""+ id +"_valor_"+ nombre +"\" class=\"elemento"+ clase +"\">"+( objeto  ? "Sí" : "No")   +"</div>"
        when "importe", "gasto.importe"
          then "<div id=\""+ id +"_valor_"+ nombre +"\" class=\"elemento"+ clase +"\">"+   number_with_delimiter(('%.2f' % objeto).to_s , :separator => ",", :delimiter => ".") +"</div>"
        when /fecha/
          then "<div id=\""+ id +"_valor_"+ nombre +"\" class=\"elemento"+ clase +"\">"+( objeto.strftime('%d/%m/%Y') )   +"</div>"
        when "porcentaje"
          then "<div id=\""+ id +"_valor_"+ nombre +"\" class=\"elemento"+ clase +"\">"+ ( objeto * 100 ).to_i.to_s  + "%</div>"
        else
          "<div id=\""+ id +"_valor_"+ nombre +"\" class=\"elemento"+ clase +"\" title='"+objeto.to_s+"'>"+( objeto && objeto.to_s != "" ? truncate(objeto.to_s, :length => ( CARACTERES[clase] || 15 )) : "&nbsp;")   +"</div>"
      end
    rescue
     "<div id=\""+ id +"_valor_"+ nombre +"\" class=\"elemento"+ clase +"\">&nbsp;</div>"
    end
  end

  # paginación, se integra en final_listado
  def paginacion elementopaginado, elementosxpagina
    formulario = "<div class='fila' id='paginacion'>\n" + (will_paginate(elementopaginado, :prev_label => "<< "+_("Anterior"), :next_label => _("Siguiente") + " >>", :class => "elemento3") or " ")
    formulario << "<div class='elementoderecha'> "+ informacion_paginacion(elementopaginado)  + "</div>"
    formulario << "<div class='linea'></div></div>"
  end

  # completa paginacion
  def informacion_paginacion collection
      if collection.total_pages < 2
        case collection.size
        when 0; "<b>" + _("No tiene elementos") + "</b>"
        when 1; "<b>" + _("Mostrando 1 elemento") + "</b>"
        else;   "<b>" + _("Mostrando todos los elementos: ") + (collection.size).to_s + "</b>"
        end
      else
        _("Mostrando elementos") + " <b>"+ (collection.offset + 1).to_s + " - " + (collection.offset + collection.length).to_s + "</b> de <b> " + (collection.total_entries).to_s +
            "</b>" +  _(" en total")
      end
  end

  # popup con trigger click para informacion adicional de un objeto
  #   metemos este metodo para no pisar ventana_popup y permitir el cambio progresivo
  def ventana_info_popup objeto, otros={}
      objeto_id = otros[:id] ? otros[:id] : 'objeto_' + objeto.class.name + "_" + objeto.id.to_s
      cadena = '<span id="' + objeto_id + '" class="popup_link">' + icono("informacion", _("informacion adicional")) + '</span>'
      cadena << '<div id="' + objeto_id + '_popup" class="popup" style="display:none">'
      for elemento in otros[:campos]
        campo = elemento[2]
        if campo.class.to_s != "Array"
          cadena << '<div class="fila"><b>' + (elemento[0]=='&nbsp;' ? campo.humanize.capitalize : elemento[0]) + ': </b>'

          valor = objeto
          campo.split('.').each { |metodo| valor = (metodo =~ /(\S+)\s(\S+)/ ? valor.send($1,$2) : valor.send(metodo)) if valor }
          if valor.class.to_s == "Array"
            valor.each do |a|
              a.each { |elemento| cadena << "<br>" + elemento }
            end
          else
            cadena <<  valor.to_s
          end
          cadena << "</div>"
        else
          objeto.send(campo[0]).each do |elemento|
            cadena << '<div class="fila"><b>' + campo[0].humanize.capitalize + '</b></div>'
            for subcampo in campo[1]
              cadena << '<div class="fila">&nbsp;&nbsp;&nbsp;&nbsp;<b>' + subcampo.humanize.capitalize + ': </b>'
              valor = elemento
              subcampo.split('.').each { |metodo| valor = (metodo =~ /(\S+)\s(\S+)/ ? valor.send($1,$2) : valor.send(metodo)) if valor }
              cadena << valor.to_s + '</div>'
            end
          end
        end
      end
      cadena << eval( 'javascript_tag "new Popup(\"' + objeto_id + '_popup\",\"' + objeto_id + '\", {trigger:\'click\'} )"' )
      return cadena << '</div>'
  end

  # popup con trigger click
  def ventana_popup objeto, otros={}
    #begin
      objeto_id = otros[:id] ? otros[:id] : 'objeto_' + objeto.class.name + "_" + objeto.id.to_s
      cadena = '<span id="' + objeto_id + '" class="popup_link">' + icono("informacion", _("informacion adicional")) + '</span>'
      cadena << '<div id="' + objeto_id + '_popup" class="popup" style="display:none">'
      for campo in otros[:campos]
        if campo.class.to_s != "Array"
          case campo
          when /^libro/
            then cadena << '<div class="fila"><b>Cuenta: </b>'
            else cadena << '<div class="fila"><b>' + campo.humanize.capitalize  + ': </b>'
          end

          case campo
          when /^actividades|^financiadores/
            then
              objeto_nombre = objeto.class.name.downcase
              array = eval( "objeto." + objeto_nombre + "_x_actividad" ) if campo == "actividades"
              array = eval( "objeto." + objeto_nombre + "_x_agente" ) if campo == "financiadores"
              nombre = ""
              array.each{ |a|
                cadena << "<br>"
                array.each{ |x| nombre = Actividad.find( x.actividad_id).codigo} if campo == "actividades"
                array.each{ |x| nombre = Agente.find( x.agente_id).nombre} if campo == "financiadores"
                cadena << nombre + " : " + (a.importe).to_s 
              }
              cadena << '</div>'
            else
              valor = objeto
              campo.split('.').each { |metodo| valor = valor.send(metodo) if valor}
              cadena <<  valor.to_s + '</div>'
          end
        else
          objeto.send(campo[0]).each do |elemento|
            cadena << '<div class="fila"><b>' + campo[0].humanize.capitalize + '</b></div>'
            for subcampo in campo[1]
              cadena << '<div class="fila">&nbsp;&nbsp;&nbsp;&nbsp;<b>' + subcampo.humanize.capitalize + ': </b>'
              valor = elemento 
              subcampo.split('.').each { |metodo| valor = valor.send(metodo) if valor}
              cadena << valor.to_s + '</div>'
            end
          end
        end
      end
      cadena << eval( 'javascript_tag "new Popup(\"' + objeto_id + '_popup\",\"' + objeto_id + '\", {trigger:\'click\'} )"' )
      return cadena << '</div>'
    #rescue
    #   '<p><span id="objeto_link_' + objeto.id.to_s + '"></span></p>'
    #end
  end


  # dibuja un mensage flash
  def mensaje cadena
   return ("<div id = 'mensaje'>" + cadena + "</div>") if cadena.class == String
   return ("<div id = 'mensaje'><ul>" + cadena.inject("") {|suma, e | suma + "<li>" + e +  "</li>"} + "</ul></div>") if cadena.class == Array
  end

  # dibuja el mensaje de error o de exito
  def mensaje_error objeto, otros={}
    if objeto.class == String
      cadena = '<div id="mensajeerror">'
      cadena << objeto
    else
      if objeto.errors.empty?
        cadena = '<div id="mensajeok">'
        cadena << _("Los datos se han guardado correctamente.") unless otros[:eliminar]
        cadena << _("Se ha eliminado correctamente.") if otros[:eliminar]
      else
        cadena = '<div id="mensajeerror">'
        cadena << _("Se han producido errores.") + "<br>"
        objeto.errors.each {|a, m| cadena += m + "<br>" }
      end
    end
    return cadena << "</div>"
  end

  # Dibuja el mensaje de error o de exito, tras la modificacion de algun objeto. Incluye un vinculo para volver a editar el objeto. Se puede especificar dicho vinculo
  def mensaje_objeto_modificado otros={}
    cadena = '<div id="mensajeok">' + _("Los datos se han guardado correctamente.") if otros[:errors].empty?
    unless otros[:errors].empty?
      cadena = '<div id="mensajeerror">' + _("Se han producido errores.") + "<br>"
      otros[:errors].each {|a, m| cadena += m + "<br>" }
    end
    cadena << "<BR>"
    cadena <<  modal(_("Volver a editar"), (otros[:url] || { :action => 'editar_nuevo', :id => otros[:id] }), _("Volver a editar el ultimo elemento editado" ), {:width => "850", :height => "310"}) if otros[:id] or otros[:url]
    cadena <<  modal(_("Volver a editar"), (otros[:url] || { :action => 'editar_ultimo' }), _("Volver a editar el ultimo elemento editado" ), {:width => "850", :height => "310"}) if otros[:recuperar]
    return cadena << "</div>"
  end


  # dibuja filas de la tabla
#  def fila_tabla columnas, nombre, id, clases
#    fila = '<div class = "fila'+ clases[2] +'">'
#    fila << '<div class="elemento'+ clases[0] +'">' + nombre + '</div>'
#    for columna in columnas
#      if valor_celda(columna, id) != "&nbsp;"
#        fila << '<div class="elemento'+ clases[1] +'">' + number_with_delimiter(('%.2f' % valor_celda(columna, id) ).to_s , :separator => ",", :delimiter => ".") + '</div>'
#      else
#        fila << '<div class="elemento'+ clases[1] +'">' + valor_celda(columna, id) + '</div>'
#      end
#    end
#    fila << '<div class = "linea"></div></div>'
#  end


  # dibuja las filas de la tabla
  def fila_tabla_rotulo columnas
    fila = '<div class = "filaDos"><b>'
    for columna in columnas
      fila << '<div class="elemento'+ columna[1]+ '">'
      fila << celda_formateada(columna[0])
      fila << '</div>'
    end
    fila << '</b><div class = "linea"></div></div>'
  end

  # Dibuja una tabla
  def dibuja_tabla filas
    salida = '<div class = "tabla">'
    cabecera = Array.new
    for fila in filas
      if fila[:cabecera]
        salida << fila_tabla_rotulo(fila[:cabecera])
        cabecera = fila[:cabecera]
      else
        salida << '<div class="fila">'
        i = 0
        fila[:contenido].each do |elemento|
          salida << '<div class="elemento' + (cabecera.length > i ? cabecera[i][1] : '1_2') + '">' + celda_formateada(elemento) + '</div>'
          i+=1
        end
        salida << '<div class="linea"></div></div>'
      end
    end
    salida << '</div>'
  end

  # devuelve una cadena adecuada al tipo de contenido
  def celda_formateada celda
    #puts "-----------------> " + celda.to_s + " es de tipo " + celda.class.to_s
    return (celda == "" ? "&nbsp;" : celda) if celda.is_a? String
    return celda.strftime('%d/%m/%Y') if celda.is_a? Date
    #return I18n.l celda if celda.is_a? Date
    return number_with_delimiter(('%.2f' % (celda || 0)).to_s , :separator => ",", :delimiter => ".") unless celda.is_a? String
  end

  # 
#  def valor_celda columna, identificador
#    valor = columna.detect {|v| v[:id] == identificador}
#    return (valor ? ('%.2f' % valor[:importe].to_s) : "&nbsp;")
#  end


  # Ventana modal (*otros para futuro uso)
  def modal( rotulo, url, titulo, otros={} )
    if eval( "@" + singularizar_seccion ) and eval( "@" + singularizar_seccion ).id
      cadena = params[:seccion].gsub(/(.*)(s)/) {$1.gsub(/one/, "ón").capitalize} + ": " + eval( "@" + singularizar_seccion ).nombre + "<br>"
    else
      cadena = ""
    end
    link_to rotulo, url, :title => titulo, :onclick => "Modalbox.show(this.href, {title: '" + cadena + titulo + "', width:" + (otros[:width] ? otros[:width].to_s : "820") + (otros[:height] ? ",height:" + otros[:height].to_s : "") + "}); return false;", :id => (otros[:id] || "")
  end

  # Ventana modal que pide confirmacion para el borrado de un elemento
  def modal_borrado ( rotulo, url, titulo, texto, otros={} )
    # Falta añadir al titulo de la ventana modal el mismo texto superior que llevan las modales sobre la variable de session.
    cadena = '<div style="display:none;" id="'+ (otros[:id] || url[:id].to_s ) +'_modalconfirmar" class="elemento2_tc">'
    cadena << titulo + ': <br><B>' + texto + '<br><br>'
    cadena << '<div class="fila"><a href="#" onclick="Modalbox.hide()"> Cancelar </a> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; '
    cadena << link_to( "Confirmar", url, :id => otros[:id].to_s + "_confirmar") unless otros[:ajax]
    cadena << link_to_remote( "Confirmar", :url => url, :html =>  {:id => otros[:id].to_s + "_confirmar"}) if otros[:ajax]
    cadena << '</b></div></div>'
    cadena << "<a id=\"#{ (otros[:id] || url[:id].to_s )  }\" onclick=\"Modalbox.show($('#{ (otros[:id] || url[:id].to_s )  }_modalconfirmar'), {title: '" + titulo + "', width: 600,transitions:false}); return false;\" href=\"#\" title='"+ url[:action].to_s + "'>"
    cadena << rotulo
    cadena << "</a>"
    return cadena
  end


  def spinner_formulario_no_se_usa
   #return :loading =>          "Element.show('spinner'); Element.hide('botonguardar'); ", :complete => "Element.hide('spinner'); Element.show('botonguardar');"
   return {:loading => "Element.show('spinner'); Element.hide('botonguardar');", :complete => "Element.hide('spinner');Element.show('botonguardar');"}
  end

  def singularizar_seccion
    singularizar(params[:seccion])
  end

  def singularizar nombre
    nombre.gsub(/(.*)(s)/) {$1.gsub(/one/, "on")}
  end

end

