#--
#
#################################################################################
# Copyright 2011 CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# metodos de navegación utilizados en el layout 

module LayoutHelper

  def ruta_seccion
    case params[:seccion]
      when "administracion" then
        _("Administración")
      when "proyectos" then
        cadena = _("Proyecto") + "&nbsp;>>&nbsp;"
        if @proyecto
          cadena + truncate(@proyecto.nombre, :length =>25)
        else
          cadena + _("Listado de proyectos asignados")
        end
      when "socios" then
        _("Gestión de socios")
      when "cuadromando" then
        _("Cuadro de Mando")
      when "agentes" then
	cadena = _("Agente") + "&nbsp;>>&nbsp;"
        if @agente
          cadena + truncate(@agente.nombre, :lenght => 23)
        else
          cadena += _("Listado de agentes asignados")
        end
      when "inicio" then
        _("Tareas asignadas al usuario") + " <i>"+session[:usuario_identificado].nombre+"</i>"
      when "documentos" then
        _("Documentos Comunes")
      else
        params[:seccion]
    end
  end

  def ruta_controlador
    cadena = ""
    cadena_controladores = "<ul class='menu'>"
    for controlador in controladores_seccion
       texto_controlador = controlador[:rotulo] if controlador[:controlador] == params[:controller]
       cadena_controladores += "<li>" + link_to(controlador[:rotulo], :controller => controlador[:controlador]) + "</li>"
    end
    cadena_controladores += "</ul>"
    cadena += link_to(texto_controlador + cadena_controladores, :controller => params[:controller])
    return cadena
  end

  def ruta_accion
    cadena = ""
    cadena_acciones = "<ul class='menu'>"
    acciones, mensaje_acciones = acciones_controlador
    texto_accion = acciones[0][:rotulo]
    for menu in acciones
      texto_accion = menu[:rotulo] if menu[:accion] == params[:action]
      cadena_acciones += "<li>" + link_to(menu[:rotulo] , :action => menu[:accion], :pestana => menu[:pestana]) + "</li>"
    end
    cadena_acciones += "</ul>"
    cadena += link_to(texto_accion + cadena_acciones)
  end

  def mensaje_estado
  # TODO: Lo metemos en un array que podría ser sacado a un variable de inicializacion para la configuracion
  case params[:seccion]
    when "administracion" then
      cadena = "<div id='resaltado'>Administracion de "
      case params[:controller]
        when "libro" then  cadena + "Cuentas </div>"
        else cadena + params[:controller].humanize.capitalize + "</div>"
      end

    when "proyectos" then
      if @proyecto
        cadena = "<div id='resaltado'>" + truncate(@proyecto.nombre, :length =>25) + "</div> <div id='divisor'>>></div> " unless params[:controller] == "proyecto"
      end
      case params[:controller]
         when "proyecto" then "<div id='resaltado'> Listado de proyecto asignados </div>"
         when "importacion" then cadena + "<div> Importación </div>"
         when "presupuesto_proyectos" then cadena + "<div> Presupuesto </div>"
         when "exportacion" then cadena + "<div> Exportación </div>"
         else    cadena + "<div id='resaltado'>" + params[:controller].humanize.capitalize + "</div>"
      end
    when "socios" then
      cadena = "<div id='resaltado'>Gestión de socios</div> <div id='divisor'>>></div> <div id='resaltado' >" + params[:controller].humanize.capitalize + "</div>"

    when "cuadromando" then
      cadena = "<div id='resaltado'>Cuadro de Mando</div>"

    when "agentes" then
      cadena = "<div id='resaltado'>" + truncate(@agente.nombre, :lenght => 23) + "</div> <div id='divisor'>>></div> " unless params[:controller] == "agente"
        case params[:controller]
           when "agente" then "<div id='resaltado'>Listado de agentes asignadas</div>"
           else  cadena + "<div id='resaltado' >" + params[:controller].humanize.capitalize + "</div>"
        end
      when "inicio" then
        cadena = "<div id='resaltado'>Inicio</div> <div id='divisor'>>></div><div id='resaltado'>Tareas asignadas al usuario <i>"+session[:usuario_identificado].nombre+"</i></div>"
      when "documentos" then
        cadena = "<div id='resaltado'>Documentacion</div> <div id='divisor'>>></div><div id='resaltado'>Documentos Comunes</div>"
      else
        params[:seccion]
    end
  end

  # Para cada seccion se definen aqui los controladores a los que se tendran acceso.
  # TODO: Estaria bien que cambiemos esto por controladores_administracionministracionministracion, controladores_proyectos, controladores_ ... etc
  def controladores_seccion
    controladores_fundamentales = [ { :rotulo => _("Estado") , :controlador => "estado"},
                                    { :rotulo => _("Tareas") , :controlador => "tarea"},
                                    { :rotulo => _("Documentos") , :controlador => "documento"}]
     case params[:seccion]
        when "proyectos"
            if params[:action] == "listado_usuario"
              []
            else
              controladores = [ { :rotulo => _("Datos") , :controlador => "datos_proyecto"},
                               { :rotulo => _("Matriz") , :controlador => "matriz"},
                                { :rotulo => _("Presupuesto") , :controlador => "presupuesto_proyectos"},
                                { :rotulo => _("Gastos"), :controlador => "gasto_proyectos"},
                                { :rotulo => _("Movimientos"), :controlador => "transferencia" },
                               # { :rotulo => _("Ingresos"), :controlador => "ingreso" },
                                { :rotulo => _("Exportación") , :controlador => "exportacion"},
                                { :rotulo => _("Importación") , :controlador => "importacion"},
                                { :rotulo => _("Resumen"), :controlador => "resumen_proyecto" },
                                { :rotulo => _("Tasa Cambio") , :controlador => "tasa_cambio"},
                                { :rotulo => _("Partidas") , :controlador => "partida_financiacion"},
                               # { :rotulo => _("Informes") , :controlador => "informe"}
                               ]
              if @proyecto and @proyecto.estado_actual
                controladores_fundamentales + controladores.select {|c| @proyecto.estado_actual.definicion_estado.send( c[:controlador] ) }
              else
                controladores_fundamentales
              end
            end
        when "agentes"
          if params[:action] == "listado_usuario"
            []
          else
            [{:rotulo => _("Datos agente"), :controlador => "datos_agente" },
             {:rotulo => _("Presupuesto"), :controlador => "presupuesto_agentes" },
             {:rotulo => _("Gastos"), :controlador => "gasto_agentes" },
             {:rotulo => _("Tasa Cambio"), :controlador => "tasa_cambio" },
             {:rotulo => _("Movimientos"), :controlador => "transferencia"},
             { :rotulo => _("Exportación") , :controlador => "exportacion"},
             { :rotulo => _("Importación") , :controlador => "importacion"},
             {:rotulo => _("Resumen"), :controlador => "resumen_agente"}]
           end
        when "administracion"
            [ { :rotulo => _("Agentes"), :controlador => "agente" },
              { :rotulo => _("Cuentas"), :controlador => "libro" },
              { :rotulo => _("Proyectos"), :controlador => "proyecto"},
              { :rotulo => _("Usuarios"), :controlador => "usuario"},
              { :rotulo => _("Datos Básicos"), :controlador => "datos_basicos"},
              { :rotulo => _("Etiquetas"), :controlador => "etiqueta"},
              { :rotulo => _("Plantillas de Exportación"), :controlador => "documento"},
              { :rotulo => _("Workflow"), :controlador => "definicion_estado"},
              { :rotulo => _("Backup"), :controlador => "backup"} ]
        when "socios"
            [ {:rotulo => _("Socios"), :controlador => "socio"},
              {:rotulo => _("Pagos"), :controlador => "pago_socio"},
              {:rotulo => _("Vista Resumen Socios"), :controlador => "resumen_socio"},
              #{:rotulo => _("Exportaciones"), :controlador => "exportacion"},
	    ]
        else
          []
        end
  end

  # Se llama al metodo menu_acciones del controlador en el que nos encontramos para ver las acciones que ofrece para la navegacion dicho controlador en dicha seccion.
  def acciones_controlador
  case controller.controller_name

    when "datos_basicos"
      return [{:rotulo => _("Pais"), :accion => "listado_pais"}, {:rotulo => _("A. Geográfica"), :accion => "listado_area_geografica"}, {:rotulo => _("Moneda"), :accion => "listado_moneda"}, {:rotulo => _("Partida"), :accion => "listado_partida"}, {:rotulo => _("Sec. Población"), :accion => "listado_sector_poblacion"}, {:rotulo => _("Sec. Intervención"), :accion => "listado_sector_intervencion"}, {:rotulo => _("A. Actuación"), :accion => "listado_area_actuacion"}, {:rotulo => _("Marcados"), :accion => "listado_marcado"},{:rotulo => _("Tareas"), :accion => "listado_tipo_tarea"},{:rotulo => _("Estado Tareas"), :accion => "listado_estado_tarea"},{:rotulo => _("Datos Proyecto"), :accion => "listado_definicion_dato"}], "Seleccionar"

    when "datos_proyecto"
      return [{:rotulo => _("Identificación"), :accion => "datos_proyecto_dinamicos_identificacion", :pestana => "identificacion"},{:rotulo => _("Contexto"), :accion => "datos_proyecto_dinamicos_contexto", :pestana => "contexto"},{:rotulo => _('Objetivos'), :accion => "datos_proyecto_dinamicos_objetivos", :pestana => 'objetivos'},{:rotulo => _("Beneficiarios"), :accion => "beneficiarios"}, {:rotulo => _("Relaciones"), :accion => "relaciones"}, {:rotulo => _("Etapas"), :accion => "etapas"} ], " "

    when "datos_financiacion"
      return [{:rotulo => _("Etapas"), :accion => "etapas"}, {:rotulo => _("Proyectos"), :accion => "proyectos_x_financiacion"}], ""

    when "datos_agente"
      return [{:rotulo => _("Etapas"), :accion => "etapas"}, {:rotulo => _("Monedas relacionadas"), :accion => "monedas"}], ""

    when "resumen_proyecto"
      return  [{:rotulo => _("Matriz"), :accion => "matriz"}, {:rotulo => _("Presupuesto"), :accion => "presupuesto"}, {:rotulo => _("Seguimiento gasto"), :accion => "gasto"}, {:rotulo => _("Arqueo de Cuenta/Caja"), :accion => "arqueo_caja"}], ""

    when "resumen_agente"
      return  [ {:rotulo => _("Presupuesto"), :accion => "presupuesto"}, {:rotulo => _("Seguimiento gasto"), :accion => "gasto"}, {:rotulo => _("Arqueo de Caja"), :accion => "arqueo_caja"}], ""

    when "resumen_financiacion"
      return  [{:rotulo => _("Presupuesto"), :accion => "presupuesto"}, {:rotulo => _("Gasto"), :accion => "gasto"}], ""

    when "matriz"
      return [{:rotulo => _("Matriz general"), :accion => "listado"}, {:rotulo => _("Matriz por pais y etapa"), :accion => "listado_filtrado"}, { :rotulo => _("Cronograma"), :accion => "cronograma"}, { :rotulo => _("Variables de Indicadores"), :accion => "variables"}, { :rotulo => _("Gestion de subactividades"), :accion => "subactividades"}  ], ""

    when "presupuesto_proyectos"
      return  [{:rotulo => _("Presupuesto por partidas"), :accion => "listado"}, {:rotulo => _("Presupuesto por actividades"), :accion => "listado_por_actividades"}], ""

    when "gasto_proyectos"
      return [{:rotulo => _("Gestión de Gastos"), :accion => "listado"}, {:rotulo => (_"Gastos Cofinanciables"), :accion => "cofinanciables"}, {:rotulo => _("Numeración facturas"), :accion => "listado_facturas"} ], ""

    else
      []
    end
  end

  # Genera un boton de información
  def mensaje_informacion
    objeto_id = "ayuda_menu"
    cadena = '<span id="' + objeto_id + '" class="popup_link">' + icono("informacion", _("Ayuda")) + '</span>'
    cadena << '<div id="' + objeto_id + '_popup" class="popup" style="display:none">'
    texto_ayuda(params[:seccion], params[:controller], params[:action]).each do |linea|
      cadena << simple_format(linea)
    end
    cadena << eval( 'javascript_tag "new Popup(\"' + objeto_id + '_popup\",\"' + objeto_id + '\", {position:\'auto\',trigger:\'click\'} )"' )
    return cadena << '</div>'
  end

end
