#--
#
#################################################################################
# Copyright 2011 CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
class VPresupuestoDetallado < ActiveRecord::Base

  # valores =  proyecto_id (0), moneda_id (1), implementador_id (2), fecha_inicio (3), fecha_fin (4), tasa_cambio (5)

  named_scope :partida_de_implementador, lambda { |*valores| {
                                 :select => "partida_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, partida_id #{moneda valores[1]}  #{agente valores[2], "implementador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "implementador")  } }


  named_scope :partida_de_financiador, lambda { |*valores| {
                                 :select => "partida_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, partida_id #{moneda valores[1]}  #{agente valores[2], "financiador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "financiador")  } }

  named_scope :actividad_de_implementador, lambda { |*valores| {
                                 :select => "actividad_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, actividad_id #{moneda valores[1]}  #{agente valores[2], "implementador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "implementador")  } }
                                    
  named_scope :actividad_de_financiador, lambda { |*valores| {
                                 :select => "actividad_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, actividad_id #{moneda valores[1]}  #{agente valores[2], "financiador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "financiador")  } }

  named_scope :partida_proyecto_de_implementador, lambda { |*valores| {
                                 :select => "partida_proyecto_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, partida_proyecto_id #{moneda valores[1]}  #{agente valores[2], "implementador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "implementador")  } }

                                    
  named_scope :partida_proyecto_de_financiador, lambda { |*valores| {
                                 :select => "partida_proyecto_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, partida_proyecto_id #{moneda valores[1]}  #{agente valores[2], "financiador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "financiador")  } }

  named_scope :partida_de_implementador_sin_proyecto, lambda { |*valores| {
                                 :select => "partida_id as fila_id, #{importe valores[0], valores[4]} as importe", 
                                 :group => "partida_id #{moneda valores[0]}  #{agente valores[1], "implementador"} ",
                                 :conditions => condiciones_sin_proyecto(valores[0], valores[1], valores[2], valores[3], "implementador", valores[5])  } }


  named_scope :implementador_sin_proyecto, lambda { |*valores| {
                                 :select => "partida_nombre , #{importe valores[0], valores[4]} as importe, proyecto_nombre, presupuesto_id , presupuesto_concepto, partida_codigo", 
                                 :group => "presupuesto_id #{moneda valores[0]}  #{agente valores[1], "implementador"} ",
                                 :conditions => condiciones_sin_proyecto(valores[0], valores[1], valores[2], valores[3], "implementador", valores[5]),
                                 :order => "partida_codigo"  } }


     
  def self.importe moneda_id, tasa_cambio
    importe = if  moneda_id == "todas";  "sum(importe_moneda_base)"
               elsif tasa_cambio == "0"; "sum(importe)"
               elsif tasa_cambio == "1"; "sum(importe_moneda_base)"; end
  end  

  def self.moneda moneda_id
      return moneda_id == "todas" ? "" : ", moneda_id "
  end

  def self.agente agente_id, agente_rol
      return agente_id == "todos" ? "" : ", #{agente_rol}_id "
  end

  def self.condiciones proyecto_id, moneda_id, agente_id, fecha_inicio, fecha_fin, agente_rol
     condiciones = {"proyecto_id" => proyecto_id, "fecha_inicio" => fecha_inicio..fecha_fin, "fecha_fin" => fecha_inicio..fecha_fin }
     condiciones["moneda_id"] = moneda_id unless moneda_id == "todas"
     condiciones[agente_rol + "_id"] = agente_id unless agente_id == "todos"
     return condiciones
  end

  def self.condiciones_sin_proyecto moneda_id, agente_id, fecha_inicio, fecha_fin, agente_rol, partida_id
     condiciones = {"fecha_inicio" => fecha_inicio..fecha_fin, "fecha_fin" => fecha_inicio..fecha_fin}
     condiciones["moneda_id"] = moneda_id unless moneda_id == "todas"
     condiciones[agente_rol + "_id"] = agente_id unless agente_id == "todos"
     condiciones["partida_id"] = partida_id if partida_id
     return condiciones
  end


end
