class ProcedureXmlMatrizDeUnProyecto < ActiveRecord::Migration
  def self.up
    execute <<-__EOI
CREATE DEFINER=CURRENT_USER FUNCTION `xml_matriz_de_un_proyecto`(proyecto_id INT) RETURNS longtext CHARSET utf8
BEGIN
  DECLARE tmp longtext;
  set tmp=
  (SELECT  
    group_concat(
    '<oe ',
      'codigo="',ifnull(o.codigo,''),'" ',
      'descripcion="',ifnull(o.descripcion,''),
      '" > ',
      IFNULL(xml_indicador_de_un_objetivo_especifico(o.id),''),
      IFNULL(xml_fuente_de_un_objetivo_especifico(o.id),''),
      IFNULL(xml_hipotesis_de_un_objetivo_especifico(o.id),''),
      IFNULL(xml_resultado_de_un_objetivo_especifico(o.id),''),
    '</oe>'
      separator '') as tmp
    FROM
      objetivo_especifico o
    WHERE 
      o.proyecto_id=proyecto_id
    );

  SET tmp= concat(
    '<?xml version="1.0" encoding="UTF-8"?>',
    '<matriz proyecto_id="',
    proyecto_id,
    '">',
    IFNULL(tmp,''),
    '</matriz>'
    );

  return tmp;
END;
__EOI

  end

  def self.down
    execute "DROP FUNCTION IF EXISTS xml_matriz_de_un_proyecto"
  end
end
