class CambiarEtapaDetalleActividadDetallePresupuesto < ActiveRecord::Migration

  def self.up

    remove_column :actividad, :fecha_inicio
    remove_column :actividad, :fecha_fin

    create_table :actividad_detallada do |t|
      t.integer :mes
      t.integer :etapa_id
      t.integer :actividad_id
      t.timestamps
     end
    
    add_column :presupuesto, :etapa_id, :integer

    # Ponemos una etapa automaticamente.
    Presupuesto.find(:all).each do |p|
      if p.proyecto and p.proyecto.etapa.size > 0 and p.fecha_inicio and p.fecha_fin
        etapas = p.proyecto.etapa
        etapas.each do |e|
          p.update_attribute("etapa_id", e.id) if (e.fecha_inicio <= p.fecha_inicio and e.fecha_fin >= p.fecha_fin)
        end
      end
    end 

    remove_column :presupuesto, :fecha_inicio
    remove_column :presupuesto, :fecha_fin

  end

  def self.down

    add_column :actividad, :fecha_inicio, :date
    add_column :actividad, :fecha_fin, :date

    drop_table :detalle_actividad

    remove_column :presupuesto, :etapa_id
    add_column :presupuesto, :fecha_inicio, :date
    add_column :presupuesto, :fecha_fin, :date

  end

end
