class AddProyectoOrigenIdToGasto < ActiveRecord::Migration
  def self.up
    add_column :gasto, :proyecto_origen_id, :integer
    # Recargamos la info de la clase
    Gasto.reset_column_information
    # Para todos los gastos que solo tengan 1 gasto_x_proyecto, le metemos el origen del proyecto
    Gasto.all.each do |gasto|
      gasto.proyecto_origen_id = gasto.gasto_x_proyecto.first.proyecto_id if gasto.gasto_x_proyecto.count == 1
      gasto.save
    end
  end

  def self.down
    remove_column :gasto, :proyecto_origen_id
  end
end
